PARAMETERS lcHelpFile, lcProject 
PRIVATE lcTitle, lcWName, lcHelpFile, lcProject, lcMenuName, lcScrName, lcOldHelp, lcOldHelpS, lcComment
m.lcTitle = ""
m.lcWName = ""
m.lcComment = ""

SELECT 0
USE (lcHelpFile) ALIAS APPHELP EXCLUSIVE
ZAP                                              &&  Clear out the old information ...
SELECT 0
USE (lcProject) ALIAS PROJECT EXCLUSIVE

SCAN FOR type = "M"								       &&  A menu file ...
	lcMenuName = PROJECT.NAME
	SELECT 0
	USE (lcMenuName) ALIAS MENU					    &&  Open the menu file ...
	WAIT WINDOW  "Generating menu level help for " + m.lcMenuName NOWAIT
	SCAN
		IF Itemnum # "0"						          &&  Not just a name ...
			IF Prompt # "\-"					          &&  Not a separator bar ...
				IF !EMPTY(Menu.Comment)				       &&  If we have text to
					SELECT APPHELP                    &&  place in the help file ...
					SCATTER MEMVAR MEMO BLANK
					IF !EMPTY(Menu.Name)              &&  If we have defined a pad name ...
						m.Topic = " "+ IIF(LEFT(Menu.Name,1) <> ;
						 "_",PROPER(Menu.Name),PROPER(STRPPRMT(MENU.PROMPT)))
						 						             &&  Handles system bar names ...
					ELSE
						m.Topic = " "+PROPER(STRPPRMT(Menu.Prompt))
												             &&  The menu prompt stripped of "\<" ...
					ENDIF
					m.Details = PADC(UPPER(ALLTRIM(SUBSTR(m.Topic,3))),37) ;
					 + CHR(13) + CHR(13) + MENU.COMMENT
					 						                &&  Add the comments to the memo field ....
					m.Class = Menu.LevelName          &&  This will be used when 
												             &&  we cross reference the submenus ....
					APPEND BLANK
					GATHER MEMVAR MEMO
					SELECT MENU
				ENDIF
			ENDIF			
		ENDIF
	ENDSCAN
USE
ENDSCAN
SELECT PROJECT
 	
SCAN FOR type = "s" 							          &&  A screen file ...
	m.lcTitle = ""
	m.lcWName = ""
	m.lcScrName = PROJECT.NAME
	WAIT WINDOW "Generating window level help for " + STRIPPAT(m.lcScrName) NOWAIT
	SELECT 0
	USE (lcScrName) ALIAS SCREEN 
****************************************************************************
** Added 20 to handle invisible buttons 12/22/93
****************************************************************************
	SCAN FOR INLIST(Objtype,1,11,12,13,14,15,16,20) .AND. ; 	
	 PLATFORM = m.lcPlatform                      &&  If it is a screen record
	 											             &&  or get object record from 
	 											             &&  the platform that we are creating help for ...

		IF objtype = 1							          &&  If it is a screen record ...
			IF !EMPTY(SCREEN.NAME)				       &&  If we have a window name or get name ...
				DO CASE
				CASE UPPER(LEFT(SCREEN.NAME,2)) ;
				 = "WR" .OR. UPPER(LEFT(SCREEN.NAME,2)) = "WM"
				 											    &&  A read window ...
					STORE SCREEN.NAME TO m.lcWName    &&  The window name ...
					m.lcWName = ALLTRIM(m.lcWName)
					m.lcWName = LOWER(m.lcWName) 
					m.lcTitle = SCREEN.TAG 
					IF INLIST(LEFT(m.lcTitle,1),["],['],[(],"[")
						m.lcTitle = SUBSTR(m.lcTitle,2,LEN(m.lcTitle)-2)   
					ENDIF												 && Strip the quotation marks ...
					m.lcTitle = ALLTRIM(m.lcTitle)
				CASE UPPER(LEFT(SCREEN.NAME,2)) = ;
				 "WC"	                               &&  A control window ...
					STORE LOWER(NAME) TO lcWName		 &&  The window name ...
					IF EMPTY(Screen.Tag)				    &&  If the window hasn't been 
																 &&  assigned a name ...
						m.lcTitle = "Control Panel"	 &&  We'll name it ...
					ELSE
						m.lcTitle = SCREEN.TAG
						IF INLIST(LEFT(m.lcTitle,1),["],['],[(],"[")
							m.lcTitle = SUBSTR(m.lcTitle,2,LEN(m.lcTitle)-2)   
						ENDIF												 && Strip the quotation marks ...
						m.lcTitle = ALLTRIM(m.lcTitle)
					ENDIF
				ENDCASE
			ENDIF
		ELSE
			IF !EMPTY(SCREEN.NAME) 			 &&  If the window has a name
				IF !EMPTY(MESSAGE) .OR. !EMPTY(COMMENT)    &&  If we have text to place in the help file
					m.lcMessage = Screen.Message
					m.lcMessage = ALLTRIM(m.lcMessage)
					m.lnMessLen = LEN(TRIM(m.lcMessage))-2
					m.lcMessage = SUBSTR(m.lcMessage,2,m.lnMessLen)	  &&  Strip the " 's 
					m.lcComment = SCREEN.COMMENT                      &&  Store the memo to a string variable 
					IF m.llGenscrnx
						m.lcComment = GETHELP(m.lcComment)                &&  Process the Directives 
					ELSE
						m.lcComment = STRPPRMT(m.lcComment)
					ENDIF
					SELECT APPHELP
					SCATTER MEMVAR MEMO BLANK
					DO CASE
						CASE INLIST(SCREEN.ObjType,12,14)
							m.Topic = IIF(EMPTY(TXTFIND(LOWER(SCREEN.Name))),PROPER(STRPPRMT(SCREEN.Picture)),TXTFIND(LOWER(SCREEN.Name)))
						OTHERWISE	
							m.Topic = IIF(EMPTY(TXTFIND(LOWER(SCREEN.Name))),PROPER(m.lcTitle),TXTFIND(LOWER(SCREEN.Name)))
					ENDCASE
					m.Details = PADC(ALLTRIM(m.Topic),37) + CHR(13) + CHR(13) + ;
					 ALLTRIM(m.lcMessage)+SPACE(2)+ m.lcComment
					 						    				 &&  Concatenate the message 
					 						    				 &&  and comments into the help file ...
					m.Read_Item = IIF(LOWER(LEFT(SCREEN.Name,2)) = ;
					 "m.", SUBSTR(LOWER(SCREEN.Name),3), LOWER(SCREEN.Name))
					m.WTitle = m.lcTitle
					m.WName = m.lcWName
					APPEND BLANK
					GATHER MEMVAR MEMO
				ENDIF
			ENDIF
		ENDIF
	ENDSCAN
	USE
ENDSCAN
SELECT APPHELP
GO TOP
WAIT WINDOW NOWAIT "Deleting empty records ..."
SCAN FOR EMPTY(TOPIC)							       &&  An empty topic can't be found ...
	DELETE										          &&  Get rid of it ...
ENDSCAN	
SCAN FOR EMPTY(DETAILS) .OR. EMPTY(READ_ITEM) .AND. !EMPTY(WNAME) .OR. ;
 EMPTY(wTitle) .AND. EMPTY(wName) .AND. !EMPTY(Read_Item)   
 																 &&  An empty memo field won't help anyone
 																 &&  nor will one that only contains 
 																 &&  the Topic ...
	DELETE										          &&  Get rid of it ...
ENDSCAN	
*This code handles MCONTROL.SCX which may occur numerous times in a CodeBook application
INDEX ON WNAME TO TMPTOP.IDX
SET INDEX TO TMPTOP.IDX
GO TOP
IF SEEK("wcmcontrol")
	WAIT WINDOW "Deleting duplicate records ..." NOWAIT
	DO WHILE WNAME = "wcmcontrol"
		lcRead_Item = Read_Item
		lnOldRec = RECNO()
		SCAN FOR WNAME = "wcmcontrol"
			IF RECNO() <> lnOldRec .AND. Read_Item = lcRead_Item
				DELETE
			ENDIF
		ENDSCAN
		GO lnOldRec
		SKIP	
	ENDDO
ENDIF
SET INDEX TO
DELETE FILE TMPTOP.IDX                           && Clean up ...
PACK
SCAN FOR EMPTY(wName)                            && Not a screen level Topic ...
	lcString = CHR(13)+CHR(13)+"See Also:  "
	lnRecord = RECNO()
	lcTopic = TOPIC
	lcClass = CLASS
	SKIP
	DO CASE
		CASE _DOS
			WAIT WINDOW NOWAIT ;
	 		"Cross Referencing "+ m.lcTopic         &&  This code snippet adds 
		CASE _WINDOWS										 &&  the cross references ...
			WAIT WINDOW NOWAIT "Cross Referencing "+ ANSITOOEM(m.lcTopic)
	ENDCASE
	SCAN FOR UPPER(Class) = UPPER(SUBSTR(lcTopic,3,10)) 
		IF EMPTY(wName)
				lcString = lcString+RTRIM(SUBSTR(Topic,3))+", "
		ENDIF
	ENDSCAN
	GO lnRecord
	IF CHR(13)+CHR(13)+"See Also:  " # (lcString)
		lcString = ALLTRIM(lcString)
		lcString = LEFT(lcString,LEN(lcString)-1)	 && Strip the last comma ...
		REPLACE Details WITH Details+lcString
	ENDIF
ENDSCAN
CLOSE DATABASES
WAIT WINDOW NOWAIT "Your help file is complete ....."
SET HELP ON
SET HELP TO &lcHelpFile
HELP
RETURN


*******************************************************************************
FUNCTION STRPPRMT       &&  Strips out junk that our users won't understand ...
*******************************************************************************
PARAMETERS lcFldName
PRIVATE lcFldName

IF INLIST(LEFT(m.lcFldName,1),["],['],[(],"[")
	m.lcFldName = SUBSTR(m.lcFldName,2,LEN(m.lcFldName)-2)   
ENDIF												 && Strip the quotation marks ...

m.lcFldName = ALLTRIM(m.lcFldName)	
	
DO CASE
	CASE UPPER("@*bhn ..\bmps\first1.bmp") $ m.lcFldName
		m.lcFldName = "First"
				
	CASE UPPER("@*bhn ..\bmps\prev1.bmp") $ m.lcFldName
		m.lcFldName = "Prior"
			
	CASE UPPER("@*bhn ..\bmps\next1.bmp") $ m.lcFldName
		m.lcFldName = "Next"
		
	CASE UPPER("@*bhn ..\bmps\last1.bmp") $ m.lcFldName
		m.lcFldName = "Last"

	CASE UPPER("@*bhn ..\bmps\list1.bmp") $ m.lcFldName
		m.lcFldName = "List"

	CASE UPPER("@*bhn ..\bmps\find1.bmp") $ m.lcFldName
		m.lcFldName = "Find"

	CASE UPPER("@*bhn ..\bmps\new1.bmp")  $ m.lcFldName
		m.lcFldName = "New"

	CASE UPPER("@*bhn ..\bmps\edit1.bmp") $ m.lcFldName
		m.lcFldName = "Edit"

	CASE UPPER("@*bhn ..\bmps\next1.bmp") $ m.lcFldName
		m.lcFldName = "Next"

	CASE UPPER("@*bhn ..\bmps\save1.bmp") $ m.lcFldName
		m.lcFldName = "Save"

	CASE UPPER("@*bhn ..\bmps\cancel1.bmp") $ m.lcFldName
		m.lcFldName = "Cancel"

	CASE UPPER("@*bhn ..\bmps\close1.bmp")  $ m.lcFldName
		m.lcFldName = "Close"

	CASE "@*C " $ m.lcFldName
		m.lcFldName = SUBSTR(m.lcFldName,ATC("@*C ",m.lcFldName)+4)	
		DO WHILE "\<" $ m.lcFldName
			m.lcFldName = SUBSTR(m.lcFldName,1,ATC("\<",m.lcFldName)-1) + ;
			 SUBSTR(m.lcFldName,ATC("\<",m.lcFldName)+2)
		ENDDO	
			
	CASE "@*HN \?" $ m.lcFldName               && This CASE statement must occur before 
															 &&  "@*HN " since "@*HN " is a 
															 &&  substring of "@*HN \?" ...
		m.lcFldName = SUBSTR(m.lcFldName,ATC("@*HN \?",m.lcFldName)+7)
		DO WHILE "\<" $ m.lcFldName
			m.lcFldName = SUBSTR(m.lcFldName,1,ATC("\<",m.lcFldName)-1) + ;
			 SUBSTR(m.lcFldName,ATC("\<",m.lcFldName)+2)
		ENDDO	

	CASE "@*HN " $ m.lcFldName
		m.lcFldName = SUBSTR(m.lcFldName,ATC("@*HN ",m.lcFldName)+5)
		DO WHILE "\<" $ m.lcFldName
			m.lcFldName = SUBSTR(m.lcFldName,1,ATC("\<",m.lcFldName)-1) + ;
			 SUBSTR(m.lcFldName,ATC("\<",m.lcFldName)+2)
		ENDDO	

	CASE "@*HT \!OK;\?CANCEL" $ UPPER(m.lcFldName)
		m.lcFldName = " Ok   < Cancel >"
	
	CASE "@*HT \<MORE;\!\?\<DONE" $ UPPER(m.lcFldName)
		m.lcFldName = " More   < Done >"	

	CASE "@*HT \?\<" $ m.lcFldName
		m.lcFldName = SUBSTR(m.lcFldName,ATC("@*HT \?\<",m.lcFldName)+9)
		DO WHILE "\<" $ m.lcFldName
			m.lcFldName = SUBSTR(m.lcFldName,1,ATC("\<",m.lcFldName)-1) + ;
			 SUBSTR(m.lcFldName,ATC("\<",m.lcFldName)+2)
		ENDDO	
		
	CASE "@*HT \!\<" $ m.lcFldName
		m.lcFldName = SUBSTR(m.lcFldName,ATC("@*HT \!\<",m.lcFldName)+9)
		DO WHILE "\<" $ m.lcFldName
			m.lcFldName = SUBSTR(m.lcFldName,1,ATC("\<",m.lcFldName)-1) + ;
			 SUBSTR(m.lcFldName,ATC("\<",m.lcFldName)+2)
		ENDDO	
		
	CASE "@*HT \!\?" $ m.lcFldName
		m.lcFldName = SUBSTR(m.lcFldName,ATC("@*HT \!\?",m.lcFldName)+9)
		DO WHILE "\<" $ m.lcFldName
			m.lcFldName = SUBSTR(m.lcFldName,1,ATC("\<",m.lcFldName)-1) + ;
			 SUBSTR(m.lcFldName,ATC("\<",m.lcFldName)+2)
		ENDDO	
			 
	CASE "@*HT \?" $ m.lcFldName
		m.lcFldName = SUBSTR(m.lcFldName,ATC("@*HT \?",m.lcFldName)+7)
		DO WHILE "\<" $ m.lcFldName
			m.lcFldName = SUBSTR(m.lcFldName,1,ATC("\<",m.lcFldName)-1) + ;
			 SUBSTR(m.lcFldName,ATC("\<",m.lcFldName)+2)
		ENDDO	
		
	CASE "@*HT \!" $ m.lcFldName
		m.lcFldName = SUBSTR(m.lcFldName,ATC("@*HT \!",m.lcFldName)+7)
		DO WHILE "\<" $ m.lcFldName
			m.lcFldName = SUBSTR(m.lcFldName,1,ATC("\<",m.lcFldName)-1) + ;
			 SUBSTR(m.lcFldName,ATC("\<",m.lcFldName)+2)
		ENDDO	
		
	CASE "@*HT " $ m.lcFldName
		m.lcFldName = SUBSTR(m.lcFldName,ATC("@*HT ",m.lcFldName)+5)
		DO WHILE "\<" $ m.lcFldName
			m.lcFldName = SUBSTR(m.lcFldName,1,ATC("\<",m.lcFldName)-1) + ;
			 SUBSTR(m.lcFldName,ATC("\<",m.lcFldName)+2)
		ENDDO	

	CASE "@*VT \!\<OK;\?\<CANCEL" $ UPPER(m.lcFldName)
		m.lcFldName = " Ok   < Cancel >"

	CASE "@*VT \?" $ m.lcFldName
		m.lcFldName = SUBSTR(m.lcFldName,ATC("@*VT \?",m.lcFldName)+7)	
		DO WHILE "\<" $ m.lcFldName
			m.lcFldName = SUBSTR(m.lcFldName,1,ATC("\<",m.lcFldName)-1) + ;
			 SUBSTR(m.lcFldName,ATC("\<",m.lcFldName)+2)
		ENDDO	
		
	CASE "@*VT \!" $ m.lcFldName
		m.lcFldName = SUBSTR(m.lcFldName,ATC("@*VT \!",m.lcFldName)+7)	
		DO WHILE "\<" $ m.lcFldName
			m.lcFldName = SUBSTR(m.lcFldName,1,ATC("\<",m.lcFldName)-1) + ;
			 SUBSTR(m.lcFldName,ATC("\<",m.lcFldName)+2)
		ENDDO	
		
	CASE "@*VT" $ m.lcFldName
		m.lcFldName = SUBSTR(m.lcFldName,ATC("@*VT",m.lcFldName)+4)	
		DO WHILE "\<" $ m.lcFldName
			m.lcFldName = SUBSTR(m.lcFldName,1,ATC("\<",m.lcFldName)-1) + ;
			 SUBSTR(m.lcFldName,ATC("\<",m.lcFldName)+2)
		ENDDO	
		
	CASE "@*VN \!COMPRESS;\?CANCEL" $ UPPER(m.lcFldName)
		m.lcFldName = " Compress   < Cancel >"
		
	CASE "@*VN \!INDEX;\?CANCEL" $ UPPER(m.lcFldName)
		m.lcFldName = " Index   < Cancel >"

	CASE "@*VN \!\<OK;\?\<CANCEL" $ UPPER(m.lcFldName)
		m.lcFldName = " Ok   < Cancel >"

	CASE "@*VN \!" $ m.lcFldName
		m.lcFldName = SUBSTR(m.lcFldName,ATC("@*VN \!",m.lcFldName)+7)	
		DO WHILE "\<" $ m.lcFldName
			m.lcFldName = SUBSTR(m.lcFldName,1,ATC("\<",m.lcFldName)-1) + ;
			 SUBSTR(m.lcFldName,ATC("\<",m.lcFldName)+2)
		ENDDO	
		
	CASE "@*VN " $ m.lcFldName
		m.lcFldName = SUBSTR(m.lcFldName,ATC("@*VN ",m.lcFldName)+5)	
		DO WHILE "\<" $ m.lcFldName
			m.lcFldName = SUBSTR(m.lcFldName,1,ATC("\<",m.lcFldName)-1) + ;
			 SUBSTR(m.lcFldName,ATC("\<",m.lcFldName)+2)
		ENDDO	

	CASE "\<" $ m.lcFldName
		m.lcFldName = SUBSTR(m.lcFldName,1,ATC("\<",m.lcFldName)-1) + ;
		 SUBSTR(m.lcFldName,ATC("\<",m.lcFldName)+2)
		DO WHILE "\<" $ m.lcFldName
			m.lcFldName = SUBSTR(m.lcFldName,1,ATC("\<",m.lcFldName)-1) + ;
			 SUBSTR(m.lcFldName,ATC("\<",m.lcFldName)+2)
		ENDDO	

	CASE "#DOSOBJ" $ UPPER(m.lcFldName) .OR. "#MACOBJ" $ UPPER(m.lcFldName) ;
	 .OR. "#WINOBJ" $ UPPER(m.lcFldName) .OR. "#UNIXOBJ" $ UPPER(m.lcFldName) ; 
	 .OR. "#STARTHELP" $ UPPER(m.lcFldName) .OR. "#ENDHELP" $ UPPER(m.lcFldName)
		IF ATC("#DOSOBJ",m.lcFldName) > 0
			m.lcFldName = SUBSTR(m.lcFldName,1,ATC("#DOSOBJ",m.lcFldName)-1) + SUBSTR(m.lcFldName,ATC("#DOSOBJ",m.lcFldName)+7)
		ENDIF
		IF ATC("#MACOBJ",m.lcFldName) > 0
			m.lcFldName = SUBSTR(m.lcFldName,1,ATC("#MACOBJ",m.lcFldName)-1) + SUBSTR(m.lcFldName,ATC("#MACOBJ",m.lcFldName)+7)
		ENDIF
		IF ATC("#WINOBJ",m.lcFldName) > 0
			m.lcFldName = SUBSTR(m.lcFldName,1,ATC("#WINOBJ",m.lcFldName)-1) + SUBSTR(m.lcFldName,ATC("#WINOBJ",m.lcFldName)+7)
		ENDIF
		IF ATC("#UNIXOBJ",m.lcFldName) > 0
			m.lcFldName = SUBSTR(m.lcFldName,1,ATC("#UNIXOBJ",m.lcFldName)-1) + SUBSTR(m.lcFldName,ATC("#UNIXOBJ",m.lcFldName)+8)
		ENDIF
		IF ATC("#STARTHELP",m.lcFldName) > 0
			m.lcFldName = SUBSTR(m.lcFldName,1,ATC("#STARTHELP",m.lcFldName)-1) + SUBSTR(m.lcFldName,ATC("#STARTHELP",m.lcFldName)+10)
		ENDIF
		IF ATC("#ENDHELP",m.lcFldName) > 0
			m.lcFldName = SUBSTR(m.lcFldName,1,ATC("#ENDHELP",m.lcFldName)-1) + SUBSTR(m.lcFldName,ATC("#ENDHELP",m.lcFldName)+8)
		ENDIF
*	OTHERWISE                                  &&  Debugging code
*		m.lcFldName = "Add case statement ..."  &&  Debugging code
ENDCASE

RETURN m.lcFldName

*******************************************************************************
FUNCTION TXTFIND    && Finds the proper text object to go with a get object ...
*******************************************************************************                                              
PARAMETERS lcGet
PRIVATE lnOldRec, RetVal 
SELECT SCREEN
m.lnOldRec = RECNO()
LOCATE FOR SCREEN.ObjType = 5 .AND. LOWER(m.lcGet) $ LOWER(SCREEN.Comment) 
*               && Find the text object containing the get in its Comment field
IF FOUND()  && If we remembered to add the get name to the text object 'Comment ...'
	m.RetVal = SCREEN.Expr
	IF INLIST(LEFT(m.RetVal,1),["],['],[(],"[")
		m.RetVal = SUBSTR(m.RetVal,2,LEN(m.RetVal)-2)    &&  Strip the quotation marks
	ENDIF 		
	m.RetVal = ALLTRIM(m.RetVal)
ELSE
	m.RetVal = ""                                 &&  We'll return an empty text string
ENDIF
GO m.lnOldRec
SELECT APPHELP
RETURN m.RetVal



*******************************************************************************
FUNCTION GETHELP
*******************************************************************************
PARAMETERS lcHelp
PRIVATE lcHelp, lnStart, lnEnd, lcRetHelp
IF "#STARTHELP" $ UPPER(m.lcHelp) ;
 .AND. "#ENDHELP" $ UPPER(m.lcHelp)                           && If we have help directives
	m.lnStart = ATC("#STARTHELP",m.lcHelp) + 10                && Find out where the help text starts  
	m.lnEnd = ATC("#ENDHELP",m.lcHelp) - m.lnStart             && Find out where the help text ends
	m.lcRetHelp = ALLTRIM(SUBSTR(m.lcHelp,m.lnStart,m.lnEnd))  && Pull the help text from the comment
ELSE
	m.lcRetHelp = ""                                           && There's nothing that we want to return
ENDIF
RETURN m.lcRetHelp                                            && Return the processed comment